<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Hcvtesting;

/**
 * HcvtestingSearch represents the model behind the search form about `app\models\Hcvtesting`.
 */
class HcvtestingSearch extends Hcvtesting
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['hcv_test_id', 'hcv_test_q1', 'hcv_test_q2', 'hcv_test_q3', 'hcv_test_q4', 'hcv_test_q5', 'hcv_test_q6', 'create_time', 'create_user', 'update_time', 'update_user'], 'integer'],
            [['hcv_test_survey', 'hcv_test_part_id', 'status','record_date'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Hcvtesting::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
			'sort'=>[
                'defaultOrder'=>['record_date'=> SORT_DESC],
            ],
        ]);
        if(empty($params))
            $params = Yii::$app->request->post();
        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'hcv_test_id' => $this->hcv_test_id,
            'hcv_test_q1' => $this->hcv_test_q1,
            'hcv_test_q2' => $this->hcv_test_q2,
            'hcv_test_q3' => $this->hcv_test_q3,
            'hcv_test_q4' => $this->hcv_test_q4,
            'hcv_test_q5' => $this->hcv_test_q5,
            'hcv_test_q6' => $this->hcv_test_q6,
            'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,
        ]);

        $query->andFilterWhere(['like', 'hcv_test_survey', $this->hcv_test_survey])
            ->andFilterWhere(['like', 'hcv_test_part_id', $this->hcv_test_part_id])
            ->andFilterWhere(['like', 'status', $this->status]);

        return $dataProvider;
    }
}
